<script setup lang="ts">
/**
 * This component is a button which enables a file upload.
 * The user of this component has to define the possbile file types and a event handler.
 * The event handler receives the file name and the file url-encoded.
 */

import { ref } from "vue";

interface Props {
  fileTypes: string;
}

const props = defineProps<Props>();

const emit = defineEmits<{
  (e: "change", data: File): void;
}>();

const fileInput = ref<HTMLInputElement | null>(null);

/* Simulate click on hidden form element */
function onFileSelectClick() {
  fileInput.value?.click(); // Simulate click on hidden file-selector-input
}

/* Reads file when file is selected*/
function onFileSelected(event: Event) {
  const files = (event.target as HTMLInputElement).files;
  if (files && files.length > 0) emit("change", files[0]);
}
</script>
<template>
  <div class="d-grid">
    <button class="btn btn-secondary btn-block" @click="onFileSelectClick">
      <slot></slot>
    </button>
    <input
      type="file"
      style="display: none"
      ref="fileInput"
      :accept="props.fileTypes"
      @change="onFileSelected"
    />
  </div>
</template>
